<html lang="en" xlmns:th="http://www.thymeleaf.org" xlmns:layout="http://ultraq.net.nz/thymeleaf/layout"
	layout:decorate="~{fragments/layout}">

<head>
	<title>Category API Pages</title>

</head>

<body>
	<div layout:fragment="content">
		<h1>CATEGORY API</h1>
		<br>
		<!--<div class="input-group">
			<input type="search" class="form-control rounded" placeholder="Search" aria-label="Search"
				aria-describedby="search-addon" />
			<button type="button" class="btn btn-list-primary">search</button>
		</div>
		<br>-->
		<div class="form-outline mb-4">
			<input type="text" class="form-control" id="key" onkeyup="search(this.value.toLowerCase())"
				placeholder="Search">
			<!--<label class="form-label" for="datatable-search-input">Search</label>-->
		</div>
		<!--<div id="datatable"></div>-->

		<!-- Button trigger modal -->
		<div class="p-3 mb-2 bg-primary text-white">
			<button type="button" class="btn btn-light" onclick="openModal()">
				Create New
			</button>

			<button id="btnMultiple" type="button" class="btn btn-light" disabled>
				Multiple Delete
			</button>
		</div>
		<!--<button onclick="getAllCategory()">Call Data API</button>-->
		<div id="isidata"></div>

		<script>
			$(function () {
				getAllCategory(0,5)
			})
			function getAllCategory(currentPage,length) {
				$.ajax({
					url: '/api/category/pagging?page='+currentPage+'&size='+length,
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						var str = "<table class='table 'border='1'>"
						str += "<thead>"
						str += "<tr>"
						str += "<th>Initial</th>"
						str += "<th>Category Name</th>"
						str += "<th style='text-align:center'>Active</th>"
						str += "<th colspan ='3' style='text-align:center'>Action</th>"
						str += "</tr>"
						str += "</thead>"
						str += "<tbody>"
						var databaru = data.category
						for (var i = 0; i < databaru.length; i++) {
							str += "<tr>"
							str += "<td>" + databaru[i].categoryInitial + "</td>"
							str += "<td>" + databaru[i].categoryName + "</td>"
							str += "<td style='text-align:center'><input type='checkbox' name='isactive' checked disabled ></td>"
							str += "<td style='text-align:center'><button class='btn btn-warning';  onclick='edit(" + databaru[i].id + ")';>Edit</button></td>"
							str += "<td style='text-align:center'><button class='btn btn-danger'; onclick='cekhapus(" + databaru[i].id + ")';>Delete</button></td>"
							str += "<td style='text-align:center'><input type='checkbox' value='" + databaru[i].id + "' class = 'classcheck' onclick = 'selectedItem(this.value)' ></td>"
							str += "</tr>"
						}

						str += "</tbody>"
						str += "</table>"
						str += "<br>"
						str += "<nav aria-label='Page navigation'>"
						str += "<ul class='pagination'>"
						str += "<li class='page-item'><a class='page-link' onclick='getAllCategory("+(data.currentPage-1)+","+length+")'>Previous</a></li>"
						var index=1
						for(var i =0; i<data.totalPages; i++){
							str += "<li class='page-item'><a id='pageslink' class='page-link' onclick='getAllCategory("+i+","+length+")'>"+index+"</a></li>"
							index++;
						}
						str += "<li class='page-item'><a class='page-link' onclick='getAllCategory("+(data.currentPage+1)+","+length+")'>Next</a></li>"
						str += "</ul>"
						str += "</nav>"
						$('#isidata').html(str)
					}
				})
			}
			function openModal() {
				var str = "<form>"
				str += "<div class='form-group'>"
				str += "<input type='hidden' value=0 id='idcategory'>"
				str += "<label>Category Initial</label>"
				str += "<input type='text' class='form-control' id='categoryInitial'>"
				str += "</div>"
				str += "<div class='form-group'>"
				str += "<label>Category Name</label>"
				str += "<input type='text' class='form-control' id='categoryName'>"
				str += "</div>"
				str += "<div class='form-group form-check'>"
				str += "<input type='checkbox' class='form-check-input' id='isActive'>"
				str += "<label class='form-check label'>Active</label>"
				str += "</div>"
				str += "</form>"

				$('.modal-title').html('Category Form')
				$('.modal-body').html(str)
				$('#btn-save').off('click').on('click', saveCategory).html('Create').addClass("btn btn-success")
				$('#modal').modal('show')
			}

			function saveCategory() {
				var id = $('#idcategory').val()
				var initial = $('#categoryInitial').val()
				var name = $('#categoryName').val()
				var active = $('#isActive')[0].checked


				var formdata = '{'
				formdata += '"categoryInitial": "' + initial + '",'
				formdata += '"categoryName": "' + name + '",'
				formdata += '"isActive": ' + active + ''
				formdata += '}'
				var link = ''
				var type = ''

				if (id == 0) {
					link = '/api/category/add'
					type = 'post'
				} else {
					link = '/api/edit/category/' + id + ''
					type = 'put'
				}
				$.ajax({
					url: link,
					type: type,
					contentType: 'application/json',
					data: formdata,
					success: function () {
						$('#modal').modal('toggle')
						getAllCategory()
					}
				})
			}

			function edit(id) {

				$.ajax({
					url: '/api/category/' + id + '',
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						var str = "<form>"

						str += "<div class='form-group'>"
						str += "<input type='hidden' value='" + id + "'id='idcategory'>"
						str += "<label>Category Initial</label>"
						str += "<input value='" + data.categoryInitial + "'type='text' class='form-control' id='categoryInitial'>"
						str += "</div>"
						str += "<div class='form-group'>"
						str += "<label>Category Name</label>"
						str += "<input value='" + data.categoryName + "' type='text' class='form-control' id='categoryName'>"
						str += "</div>"
						str += "<div class='form-group form-check'>"
						str += "<input checked type='checkbox' class='form-check-input' id='isActive'>"
						str += "<label class='form-check label'>Active</label>"
						str += "</div>"
						str += "</form>"

						$('.modal-title').html('Edit')
						$('.modal-body').html(str)
						$('#btn-save').off('click').on('click', saveCategory).html('Save Change').addClass("btn btn-warning")
						$('#modal').modal('show')
					}

				})

			}
			function cekhapus(id) {
				$.ajax({
					url: '/api/category/' + id + '',
					type: 'get',
					contentType: 'application/json',
					success: function (data) {

						var str = "<form>"
						str += "<label>Are you sure you want to delete this?</label><br>"
						str += "<input type='hidden' value='" + id + "'id='idcategory'>"
						str += "<table>"
						str += "<tr>"
						str += "<td style='text-align :right'>Category Initial</td>"
						str += "<td style='width:20px'></td>"
						str += "<td style='text-align :left'>" + data.categoryInitial + "</td>"
						str += "</tr>"
						str += "<tr>"
						str += "<td style='text-align :right'>Category Name</td>"
						str += "<td style='width:20px'></td>"
						str += "<td style='text-align :left'>" + data.categoryName + "</td>"
						str += "</tr>"
						str += "<tr>"
						str += "<td style='text-align :right'>Active</td>"
						str += "<td style='width:20px'></td>"
						str += "<td style='text-align :left'><input checked type='checkbox' id='isActive' disabled></td>"
						str += "</tr>"
						str += "</table>"
						str += "</form>"

						$('.modal-title').html('Edit')
						$('.modal-body').html(str)
						$('#btn-save').off('click').on('click', hapus).html('Delete').addClass("btn btn-danger")
						$('#modal').modal('show')
					}
				})
			}

			function hapus() {
				/*var id = $('#idcategory').val()
				var initial = $('#categoryInitial').val()
				var name = $('#categoryName').val()
				var active = $('#isActive')[0].checked


				var formdata = '{'
				formdata += '"categoryInitial": "' + initial + '",'
				formdata += '"categoryName": "' + name + '",'
				formdata += '"isActive": ' + active + ''
				formdata += '}'*/

				$.ajax({
					url: '/api/delete/category/' + id + '',
					type: 'put',
					contentType: 'application/json',
					data: formdata,
					success: function () {
						$('#modal').modal('toggle')
						getAllCategory()
					}
				})
			}

			function searchdata() {
				var input = document.getElementById("searchInput").value.toLowerCase()
				var data = document.getElementById("isidata")
				var tr = data.getElementsByTagName("tr")
				var td = "";

				for (var i = 0; i < tr.length; i++) {
					td = tr[i].getElementsByTagName("td")[1];
					if (td) {
						if (td.innerHTML.toLowerCase().indexOf(input) > -1) {
							tr[i].style.display = "";
						} else {
							tr[i].style.display = "none";
						}
					}
				}
			}

			function search(key) {
				//console.log(key)
				if (key.length != 0) {
					$.ajax({
						url: '/api/category/search/' + key + '',
						type: 'get',
						contentType: 'application/json',
						success: function (data) {
							var str = "<table class='table 'border='1'>"
							str += "<thead>"
							str += "<tr>"
							str += "<th>Initial</th>"
							str += "<th>Category Name</th>"
							str += "<th style='text-align:center'>Active</th>"
							str += "<th colspan ='2' style='text-align:center'>Action</th>"
							str += "</tr>"
							str += "</thead>"
							str += "<tbody>"
							for (var i = 0; i < data.length; i++) {
								str += "<tr>"
								str += "<td>" + data[i].categoryInitial + "</td>"
								str += "<td>" + data[i].categoryName + "</td>"
								str += "<td style='text-align:center'><input type='checkbox' name='isactive' checked disabled></td>"
								str += "<td style='text-align:center'><button class='btn btn-warning'; onclick='edit(" + data[i].id + ")';>Edit</button></td>"
								str += "<td style='text-align:center'><button class='btn btn-danger'; onclick='cekhapus(" + data[i].id + ")';>Delete</button></td>"
								str += "</tr>"
							}

							str += "</tbody>"
							str += "</table>"

							$('#isidata').html(str)
						}
					})
				} else {
					getAllCategory(0,5)
				}

			}

			function selectedItem(id) {
				var check = $('.classcheck')
				var select = []

				for (var i = 0; i < check.length; i++) {
					if (check[i].checked) {
						select.push(check[i].value)
					}
				}

				var btnMultiple = $('#btnMultiple')

				if (select.length > 0) {
					btnMultiple.attr('disabled', false).off('click').on('click', function () {
						confirmMultiple(select)
					})
				} else {
					btnMultiple.attr('disabled', true)
				}
			}

			function confirmMultiple(select) {
				var str = 'Apakah Anda yakin ingin menghapus category ini: <br>'

				for (var i = 0; i < select.length; i++) {
					//console.log[select[i]]
					$.ajax({
						url: '/api/category/' + select[i],
						type: 'get',
						contentType: 'application/json',
						success: function (data) {
							str += '<span>' + data.categoryName + '</span><br>'
							$('.modal-title').html('<h5>Hapus Category</h5>')
							$('.modal-body').html(str)
							$('#btn-save').html('Delete').off('click').on('click', function () {
								deleteMultiple(select)
							})
							$('#modal').modal('show')
						}
					})
				}
			}

			function deleteMultiple(item) {
				for (var i = 0; i < item.length; i++) {
					$.ajax({
						url: '/api/delete/category/' + item[i],
						type: 'put',
						contentType: 'application/json',
						success: function () {
							$('#modal').modal('toggle')
							getAllCategory()
						}
					})
				}
			}
		</script>
	</div>

</body>

</html>